%define debug_package %{nil}
########################################################################
# On CentOS/RHEL, if the Software Configurations Library is installed
# and Python 2.7 is installed, then it is used. This is only available
# on CentOS 6.5 for the x86_64 architecture, at this time.
########################################################################
%define __SCL   %(if [ -d /opt/rh/python27 ]; then echo 1; else echo 0; fi)

%if 0%{?__SCL} > 0
        %define PYTHON     python27
        %define python_sitelib_old_1 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
        %define python_sitelib_old_2 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
        %define python_sitelib %(echo python -c '"from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)"' | scl enable python27 -)
        %define _SCL_base %(echo $(dirname $(dirname `echo which python | scl enable python27 -`)))
        %define _bindir %(dirname `echo which python | scl enable python27 -`)
        %define _datadir %{_SCL_base}/share
        %define _mandir %{_datadir}/man
        %define _docdir %{_datadir}/doc
        %define  __os_install_post      \
            /usr/lib/rpm/redhat/brp-compress; \
            %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}}; \
            /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip}; \
            /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump}; \
            echo /usr/lib/rpm/brp-python-bytecompile python27 | scl enable %{PYTHON} - ; \
            /usr/lib/rpm/redhat/brp-python-hardlink; \
            %{!?__jar_repack:/usr/lib/rpm/redhat/brp-java-repack-jars}
%else
        %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
%endif

Name: dfwinreg
Version: 20160428
Release: 1%{?dist}
Summary: Library that provides read-only access to Windows Registry objects
Group: System Environment/Libraries
License: LGPL
Source: %{name}-%{version}.tar.gz
%if 0%{?centos} == 5
Patch1: %{name}-%{version}-patch-001
%endif
URL: https://github.com/log2timeline/dfwinreg
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       python-six
Requires:	python-construct
Requires:	libregf-python
%if 0%{?__SCL} > 0
BuildRequires:  python27-python-setuptools
Requires:       python27-python-setuptools
%else
BuildRequires:  python(abi) => 2.7
%endif

%description
dfWinReg, or Digital Forensics Windows Registry, provides read-only
access to Windows Registry objects. The goal of dfWinReg is to provide a
generic interface for accessing Windows Registry objects that resembles
the Registry key hierarchy as seen on a live Windows system.

dfWinReg originates from the Plaso project and is also based on ideas
from the winreg-kb project. It was largely rewritten and made into a
stand-alone project to provide more flexibility and allow other projects
to make use of Windows Registry functionality.

%prep
%setup -q
%if 0%{?centos} == 5
%patch1 -p1
%endif
########################################################################
# The system script that computes dependencies misidentifies the 
# python 2.7 dependency, so it is necessary to remove it from the
# dependency determination. 
########################################################################
%if %{__SCL}
mkdir -p %{_builddir}/%{name}-%{version}
cat > %{_builddir}/%{name}-%{version}/pythondeps.sh << \EOF
#!/bin/sh
%{__python_requires} $* | sed -e 's/python(abi) = 2.7/python27-python(abi) = 2.7/'
EOF
chmod +x %{_builddir}/%{name}-%{version}/pythondeps.sh
%define __python_requires %{_builddir}/%{name}-%{version}/pythondeps.sh
%endif


%build
%if 0%{?centos} == 6
%ifarch x86_64
echo python setup.py build | scl enable python27 -
%else
echo %{name} cannot be build for RHEL/CentOS 6 i386
%endif
%else
%{__python} setup.py build
%endif

%install
%{__rm} -rf %{buildroot}

%if 0%{?centos} == 6
%ifarch x86_64
echo python setup.py install --root="%{buildroot}" --record=INSTALLED_FILES | scl enable python27 -
%else
echo %{name} cannot be build for RHEL/CentOS 6 i386
%endif
%else
%{__python} setup.py install --root="%{buildroot}" --prefix="%{_prefix}" --record=INSTALLED_FILES 
%endif

%if 0%{?centos} == 7
mv %{buildroot}/usr/share/doc/%{name} %{buildroot}/usr/share/doc/%{name}-%{version}
%endif

%clean
rm -rf ${RPM_BUILD_ROOT}

%files -f INSTALLED_FILES
%defattr(644,root,root,755)
%attr(644, root, root)		%{python_sitelib}/%{name}/*.pyo

%changelog
* Wed Apr 28 2016 Lawrence R. Rogers <lrr@cert.org> 20160428-1
* Release 20160428-1
	Version 20160428

* Sat Jan 16 2016 Lawrence R. Rogers <lrr@cert.org> 20160116-1
* Release 20160116-1
`
